searchData={"items":[{"type":"task","doc":"Updates the Phoenix project generator locally.\n\n    $ mix local.phx\n\nAccepts the same command line options as `archive.install hex phx_new`.","title":"mix local.phx","ref":"Mix.Tasks.Local.Phx.html"},{"type":"task","doc":"Creates a new Phoenix project.\n\nIt expects the path of the project as an argument.\n\n    $ mix phx.new PATH [--module MODULE] [--app APP]\n\nA project at the given PATH will be created. The\napplication name and module name will be retrieved\nfrom the path, unless `--module` or `--app` is given.","title":"mix phx.new","ref":"Mix.Tasks.Phx.New.html"},{"type":"task","doc":"* `--umbrella` - generate an umbrella project,\n    with one application for your domain, and\n    a second application for the web interface.\n\n  * `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--adapter` - specify the http adapter. One of:\n      * `cowboy` - via https://github.com/elixir-plug/plug_cowboy\n      * `bandit` - via https://github.com/mtrudel/bandit\n\n    Please check the adapter docs for more information\n    and requirements. Defaults to \"bandit\".\n\n  * `--no-assets` - equivalent to `--no-esbuild` and `--no-tailwind`\n\n  * `--no-dashboard` - do not include Phoenix.LiveDashboard\n\n  * `--no-ecto` - do not generate Ecto files\n\n  * `--no-esbuild` - do not include esbuild dependencies and assets.\n    We do not recommend setting this option, unless for API only\n    applications, as doing so requires you to manually add and\n    track JavaScript dependencies\n\n  * `--no-gettext` - do not generate gettext files\n\n  * `--no-html` - do not generate HTML views\n\n  * `--no-live` - comment out LiveView socket setup in your Endpoint\n    and assets/js/app.js. Automatically disabled if --no-html is given\n\n  * `--no-mailer` - do not generate Swoosh mailer files\n\n  * `--no-tailwind` - do not include tailwind dependencies and assets.\n    The generated markup will still include Tailwind CSS classes, those\n    are left-in as reference for the subsequent styling of your layout\n    and components\n\n  * `--binary-id` - use `binary_id` as primary key type in Ecto schemas\n\n  * `--verbose` - use verbose output\n\n  * `-v`, `--version` - prints the Phoenix installer version\n\nWhen passing the `--no-ecto` flag, Phoenix generators such as\n`phx.gen.html`, `phx.gen.json`, `phx.gen.live`, and `phx.gen.context`\nmay no longer work as expected as they generate context files that rely\non Ecto for the database access. In those cases, you can pass the\n`--no-context` flag to generate most of the HTML and JSON files\nbut skip the context, allowing you to fill in the blanks as desired.\n\nSimilarly, if `--no-html` is given, the files generated by\n`phx.gen.html` will no longer work, as important HTML components\nwill be missing.","title":"Options - mix phx.new","ref":"Mix.Tasks.Phx.New.html#module-options"},{"type":"task","doc":"`mix phx.new` by default prompts you to fetch and install your\ndependencies. You can enable this behaviour by passing the\n`--install` flag or disable it with the `--no-install` flag.","title":"Installation - mix phx.new","ref":"Mix.Tasks.Phx.New.html#module-installation"},{"type":"task","doc":"$ mix phx.new hello_world\n\nIs equivalent to:\n\n    $ mix phx.new hello_world --module HelloWorld\n\nOr without the HTML and JS bits (useful for APIs):\n\n    $ mix phx.new ~/Workspace/hello_world --no-html --no-assets\n\nAs an umbrella:\n\n    $ mix phx.new hello --umbrella\n\nWould generate the following directory structure and modules:\n\n```text\nhello_umbrella/   Hello.Umbrella\n  apps/\n    hello/        Hello\n    hello_web/    HelloWeb\n```\n\nYou can read more about umbrella projects using the\nofficial [Elixir guide](https://hexdocs.pm/elixir/dependencies-and-umbrella-projects.html#umbrella-projects)\n\n## `PHX_NEW_CACHE_DIR`\n\nIn rare cases, it may be useful to copy the build from a previously\ncached build. To do this, set the `PHX_NEW_CACHE_DIR` environment\nvariable before running `mix phx.new`. For example, you could generate a\ncache by running:\n\n```shell\nmix phx.new mycache --no-install && cd mycache   && mix deps.get && mix deps.compile && mix assets.setup   && rm -rf assets config lib priv test mix.exs README.md\n```\n\nYour cached build directory should contain:\n\n    _build\n    deps\n    mix.lock\n\nThen you could run:\n\n```shell\nPHX_NEW_CACHE_DIR=/path/to/mycache mix phx.new myapp\n```\n\nThe entire cache directory will be copied to the new project, replacing\nany existing files where conflicts exist.","title":"Examples - mix phx.new","ref":"Mix.Tasks.Phx.New.html#module-examples"},{"type":"task","doc":"Creates a new Ecto project within an umbrella project.\n\nThis task is intended to create a bare Ecto project without\nweb integration, which serves as a core application of your\ndomain for web applications and your greater umbrella\nplatform to integrate with.\n\nIt expects the name of the project as an argument.\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.ecto APP [--module MODULE] [--app APP]\n\nA project at the given APP directory will be created. The\napplication name and module name will be retrieved\nfrom the application name, unless `--module` or `--app` is given.","title":"mix phx.new.ecto","ref":"Mix.Tasks.Phx.New.Ecto.html"},{"type":"task","doc":"* `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--binary-id` - use `binary_id` as primary key type\n    in Ecto schemas","title":"Options - mix phx.new.ecto","ref":"Mix.Tasks.Phx.New.Ecto.html#module-options"},{"type":"task","doc":"$ mix phx.new.ecto hello_ecto\n\nIs equivalent to:\n\n    $ mix phx.new.ecto hello_ecto --module HelloEcto","title":"Examples - mix phx.new.ecto","ref":"Mix.Tasks.Phx.New.Ecto.html#module-examples"},{"type":"task","doc":"Creates a new Phoenix web project within an umbrella project.\n\nIt expects the name of the OTP app as the first argument and\nfor the command to be run inside your umbrella application's\napps directory:\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.web APP [--module MODULE] [--app APP]\n\nThis task is intended to create a bare Phoenix project without\ndatabase integration, which interfaces with your greater\numbrella application(s).","title":"mix phx.new.web","ref":"Mix.Tasks.Phx.New.Web.html"},{"type":"task","doc":"$ mix phx.new.web hello_web\n\nIs equivalent to:\n\n    $ mix phx.new.web hello_web --module HelloWeb\n\nSupports the same options as the `phx.new` task.\nSee `Mix.Tasks.Phx.New` for details.","title":"Examples - mix phx.new.web","ref":"Mix.Tasks.Phx.New.Web.html#module-examples"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}